// ==UserScript==
// @name PeCa List
// @namespace http://peercast-theme.seesaa.net/
// @description The channel list of PeerCast.
// @include http://localhost:*/html/ja/*
// ==/UserScript==



// ■■ 設定ここから ■■

/* KPなどで配布している"差し替え用PeerCastHTML"を利用している場合、
　「true」を指定とPeerCast各ページ左上にある「Yellow Pages」のリンクを
　チャンネル一覧ページへのリンクに変更します。
　"差し替え用PeerCastHTML"を利用していない場合は「false」を指定。
*/
var bUsedRebuildHTML = false;

/* イエローページの短縮名とindex.txtのURLを指定
　name:に短縮名、url:にURLを記述してください。
　例：[{name:"▲", url:"http://△/index.txt"}, {name:"●", url:"http://○/index.txt"}];
　
　IPアドレス:ポートや名前空間などを指定する場合、そのイエローページサーバーの
　仕様に合わせてURLのパラメータを追記する必要があります。
　（※ 使用ポートが7144で名前空間を指定しない場合は追記しなくて構いません。）
　例1：url:"～index.txt?host=localhost:17144&ns=test"
　例2：url:"～index.txt?ns=aaa|bbb|ccc"
　
　pcraw_proxy経由でindex.txtを取得する場合、URLの先頭に
　”http://localhost:ポート/”を追記する必要があります。
　ポートはpcraw_proxyを生成する際に指定したものを使用します。
　例：url:"http://localhost:8080/http://～index.txt"
*/
var aYP = [
{name:"Ese", url:"http://アドレス/index.txt"}, 
{name:"KP", url:"http://アドレス/index.txt"}, 
{name:"YP", url:"http://アドレス/index.txt"}, 
{name:"XP", url:"http://localhost:ｐｃｒａｗポート/http://アドレス/index.txt"}
];
//この2行上（配列最終行）の行末にコンマ「,」は記入しないで下さい。
//上記の「アドレス」や「ｐｃｒａｗポート」の部分を書き換えて使用して下さい。
//（pcraw_proxyを使わない場合は該当する行を削除して下さい。）

// ■■ 設定ここまで ■■



window.addEventListener('load', function() {

var w = (typeof unsafeWindow == 'undefined') ? window : unsafeWindow;
var sPageName = location.href.slice(location.href.lastIndexOf("/")+1);


// ページ別に実行する内容を振り分ける
if(sPageName == "pecalist.html") {
// ★チャンネルリストを表示するpecalist.htmlでのみ以下を実行★


var nTimer = 0, nTimer2 = 0, nWait = 0, nTimeout = 0, nUp = 0, nLoaded = 0, nCheck = 0, sInt = "Z", sChk = ",.";
var bTimeout = false;
var aYPname = [];
var dNow = new Date();

//キーボードのキーを押したときの処理
var KeyDown = function(e) {
	keycode = e.which;
	var keychar = String.fromCharCode(keycode);
	var ctrl = typeof e.modifiers == 'undefined' ? e.ctrlKey : e.modifiers & Event.CONTROL_MASK; 
	var shift = typeof e.modifiers == 'undefined' ? e.shiftKey : e.modifiers & Event.SHIFT_MASK;
	if(keycode == 116 || (keycode == 82 && ctrl)) {
		e.stopPropagation();
		e.preventDefault();
		dNow = new Date();
		nUp = Number(GM_getValue("UpdateTime"));
		if((sChk.charCodeAt(0) + sChk.charCodeAt(1) == sInt.charCodeAt(0)) && (sInt.charCodeAt(0) < Math.ceil((dNow.getTime() - nUp) / 1000)) && ! w.bUpdating) {
			w.bUpdating = true;
			CheckUpdate();
		}
	}
}

// 前回更新時から一定時間経過しているかチェック
var CheckUpdate = function() {
	dNow = new Date();
	nUp = Number(GM_getValue("UpdateTime"));
	while(isNaN(nUp) || nUp == undefined || nUp == null) {
		GM_setValue("UpdateTime", String(dNow.getTime()));
		nUp = Number(GM_getValue("UpdateTime"));
	}
	if(w.bPort) {
		var bModal = (document.getElementById("f").innerHTML.length > 40) ? true : false;
		if((dNow.getTime() - nUp > 1000 * sInt.charCodeAt(0)) && (sChk.charCodeAt(0) + sChk.charCodeAt(1) == sInt.charCodeAt(0))) {
			nWait = sInt.charCodeAt(0);
			w.bNowUpdate = true;
			Update(bModal);
		} else {
			nWait = sInt.charCodeAt(0) - Math.ceil((dNow.getTime() - nUp) / 1000);
			w.PopUp("Wait", bModal, nWait);
			dNow.setTime(nUp);
			setTimeout(function(){w.OnLoad(false);}, 10);
			clearInterval(nTimer);
			nTimer = setInterval(SetTimer,1000);
		}
		var nMo = dNow.getMonth();
		var nDa = dNow.getDate();
		var nHo = dNow.getHours();
		var nMi = dNow.getMinutes();
		w.sLastUpdate = ((nMo < 10) ? "0" + nMo : nMo) + "/" + ((nDa < 10) ? "0" + nDa : nDa) + " " + ((nHo < 10) ? "0" + nHo : nHo) + ":" + ((nMi < 10) ? "0" + nMi : nMi);
	} else {
		var sPort = window.location.host;
		sPort = sPort.slice(sPort.indexOf(":")+1);
		w.$("Main").innerHTML = '<p>PeerCastで使用するポートが開いていません！</p><p>TCP：' + sPort + ' を開けるようPCまたはルーターの設定を行って下さい。</p>';
	}
}

// 更新OKまでのタイマー表示
var SetTimer = function() {
	nWait --;
	var str = "PeCa List - ";
	if(nWait > 0) {
		document.title = str + '(' + nWait + ')';
	} else {
		clearInterval(nTimer);
		document.title = str + '更新OK';
		setTimeout(function(){document.title = str + w.sLastUpdate.slice(w.sLastUpdate.lastIndexOf(" ")+1);}, 5000);
	}
}

// index.txtの読み込みタイムアウト処理
var SetTimeout = function() {
	if(nTimeout > 30 && ! bTimeout) {
		bTimeout = true;
		clearInterval(nTimer2);
		var bModal = (document.getElementById("f").innerHTML.length > 40) ? true : false;
		var aOriginal = w.swf("data").Index("Load");
		for(var i=0; i<aOriginal.length; i++) {
			for(var n=0; n<aYPname.length; n++) {
				if(aYPname[n] == aOriginal[i].name) {
					for(var x=0; x<aYP.length; x++) {
						if(aYP[x].name == aYPname[n]) {
							var dError = new Date();
							var nHo = dError.getHours();
							var nMi = dError.getMinutes();
							w.RegistIndex(true, x, aOriginal[i].name, aOriginal[i].url, w.Escape(aOriginal[i].data));
							w.AddIndex(aOriginal[i].name, aOriginal[i].url, '■■■　Error　■■■<>00000000000000000000000000000000<><><>Info<>' + aOriginal[i].name + 'の読み込みがタイムアウトしたため、前回更新時のキャッシュデータを表示しています。<>-5<>-5<>0<>ERR<><><><><><>0:00<>notice<>' + ((nHo < 10) ? "0" + nHo : nHo) + ":" + ((nMi < 10) ? "0" + nMi : nMi) + '<>0');
							break;
						}
					}
				}
			}
		}
		w.PopUp("Timeout", "", "", aYPname.toString());
		GM_setValue("UpdateTime", String(dNow.getTime()));
		clearInterval(nTimer);
		nTimer = setInterval(SetTimer,1000);
		setTimeout(function(){w.OnLoad(true);}, 10);
	} else if(nTimeout > 35) {
		console.error("SetTimeout Error : " + nTimeout + " / " + bTimeout);
		clearInterval(nTimer2);
	}
	nTimeout ++;
}

// index.txtの取得準備
var Update = function(bool) {
	nLoaded = 0, nTimeout = 0;
	bTimeout = false;
	w.na = 0, w.nTotalChannels = 0, w.nTotalListeners = 0, w.nTotalRelays = 0;
	w.aIndex = [], w.aData = [], w.aOriginal = [];
	w.oGenre = {};
	w.GetCache();
	w.PopUp("Loading", bool);
	clearInterval(nTimer2);
	nTimer2 = setInterval(SetTimeout,1000);
	aYPname = [];
	for(var i=0; i<aYP.length; i++) {
		aYPname.push(aYP[i].name);
		GetIndex(aYP[i].name, aYP[i].url, i);
	}
}

// index.txtをロード＆データを登録
var GetIndex = function(nam, url, n) {
	GM_xmlhttpRequest({
		method: 'GET',
		url: url, 
		onload: function(details) {
			if(details.status == "200" && ! bTimeout) {
				var sIndex = details.responseText;
				sIndex = sIndex.replace(/\n|\r|\r\n/g, "<>");
				sIndex = sIndex.slice(0, -3);
				w.RegistIndex(true, n, nam, url, sIndex);
				nLoaded ++;
				for(var i=0; i<aYPname.length; i++) {
					if(aYPname[i] == nam) {
						aYPname.splice(i, 1);
						break;
					}
				}
				if(nLoaded == aYP.length) {
					w.PopUp("Loaded");
					GM_setValue("UpdateTime", String(dNow.getTime()));
					clearInterval(nTimer);
					clearInterval(nTimer2);
					nTimer = setInterval(SetTimer,1000);
					setTimeout(function(){w.OnLoad(true);}, 10);
				}
			} else {
				IndexError(nam, url, details);
			}
		},
		onerror: function(details) {
			IndexError(nam, url, details);
		}
	});
}

// エラーをポップアップ表示
var IndexError = function(nam, url, details) {
	clearInterval(nTimer2);
	switch(details.status) {
		case 401:
		alert(details.status + "エラー：" + nam + "のチャンネルデータを取得するには" + nam + "管理者にパスワードを教えてもらう必要があります。");
		break;
		case 403:
		alert(details.status + "エラー：" + nam + "のチャンネルデータへのアクセスは現在禁止されています。短時間で更新した場合に403エラーとなる場合もあります。");
		break;
		case 404:
		alert(details.status + "エラー：" + nam + "のチャンネルデータが見つかりません。" + nam + "のURLが正しく設定されているか確認して下さい。");
		break;
		case 408:
		alert(details.status + "エラー：" + nam + "のチャンネルデータの読み込みがタイムアウトしました。");
		break;
		default:
		alert(details.status + "エラー：" + nam + "のチャンネルデータを正しく読み込むことができませんでした。");
	}
	w.PopUp();
	//alert("設定などを見直してからページを再読み込みしてください。");
	w.OnLoad();
}

// FlashとHTMLが読み込み終わったかチェック
var CheckLoad = function() {
	if(sChk.charCodeAt(0) + sChk.charCodeAt(1) == sInt.charCodeAt(0)) {
		if((w.bFlash && w.bLoaded) || nCheck > 5) {
			CheckUpdate();
		} else {
			nCheck ++;
			setTimeout(CheckLoad, 1000);
		}
	} else {
		alert("Error! \nPlease reinstall PeCaList.");
	}
}

window.addEventListener('keydown', KeyDown, true);
window.addEventListener('keypress', KeyDown, true);
window.addEventListener('unload', KeyDown, false);
setTimeout(CheckLoad, 100);


} else if(bUsedRebuildHTML) {
// ★pecalist.html以外のページ（情報・リレーチャンネル・設定など）で以下を実行★


function modify_single_url(doc, match_re, replace_string, node) {
	if(node.href) node.href = node.href.replace(match_re, replace_string);
}

function do_modify_url_it(doc, node, match_re, replace_string, global_flag) {
	match_re = new RegExp(match_re);
	if(global_flag) {
		var allurls = doc.getElementsByTagName('A');
		for(var i=0, url; url=allurls[i]; i++) modify_single_url(doc, match_re, replace_string, url);
	} else {
		modify_single_url(doc, match_re, replace_string, node);
	}
}

function do_modify_html_it(doc, element, match_re, replace_string) {
	match_re = new RegExp(match_re);
	if(element.innerHTML) element.innerHTML = element.innerHTML.replace(match_re, replace_string);
}

	// ページ左上の「Yellow Pages」を「チャンネルリスト」に書き換える
	do_modify_html_it(window.document,document.evaluate('/HTML[1]/BODY[1]/DIV[1]/TABLE[2]/TBODY[1]/TR[1]/TD[1]/A[1]', document, null, XPathResult.FIRST_ORDERED_NODE_TYPE,null).singleNodeValue,/Yellow Pages/,'チャンネルリスト',null);
	
	// 書き換えた"チャンネルリスト"のリンクURLを「yp_list.html」に書き換える
	do_modify_url_it(window.document,document.evaluate('/HTML[1]/BODY[1]/DIV[1]/TABLE[2]/TBODY[1]/TR[1]/TD[1]/A[1]', document, null, XPathResult.FIRST_ORDERED_NODE_TYPE,null).singleNodeValue,/http:\/\/yp\.peercast\.org\/\?host=.*/,'/html/ja/yp_list.html',false);


}

}, false);